// PDicReader.cpp: CPDicReader NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////
//	2007/03/21 hishida

#include "stdafx.h"
#include "PDicReader.h"

#ifdef _WIN32_WCE
#include "FileIO.h"
#endif

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define	_KANJI_CP	932
#define	_DEF_RELEASECONTROL	1


//////////////////////////////////////////////////////////////////////
//	o
//////////////////////////////////////////////////////////////////////
/*
	Unicodeł̃RpCw
	------------------------------------------------------------
								MBCS		Unicode
	------------------------------------------------------------
	Gg|CgV{			wWinMainCRTStartup
	vvZbT̒`		_MBCS		_UNICODE,UNICODE
	------------------------------------------------------------
*/
/*
PDIC̃f[^\

	wb_[	(256)
	gwb_[(ϒ:0)
	CfbNX(ϒ:256P)
	f[^	(ϒ:256P)

	CfbNX̊Jnʒu	=	wb_(256)


	NEWDIC2(3.0)
	(ި̈ʒu)=(ͯް)
					+(ޯ)
					+(ްۯ)*(ۯԍ)

	NEWDIC3(4.0)
	(ި̈ʒu)=(ͯް)
					+(gͯް)
					+(ޯubN)*(ubNTCY)
					+(ubNTCY)*(ۯԍ)

  	(fBXN̈ʒu)=(header_size) 
					+(extheader)
					+(index_block)*(block_size)
					+(block_size)~(ubNԍ)

					ubNTCY256

  dictype & 0x08 ȂUnicode


*/

//	BOCU-1UCS2ւ̕ϊ
int BOCU1_decode( byte*p,		// in:BOCU-1
				 int length,	// in:͕̃oCg
				 WCHAR*dest,	// out:UCS2ւ̕ϊ
				 int maxdest )	// in:dest̍ő咷
{
	ASSERT( p );
	ASSERT( dest );

    Bocu1Rx rx={ 0, 0, 0 };
    int32_t c, i, sLength;

	WCHAR*	destorg	= dest;
    i = sLength = 0;
    while( i<length && dest<destorg+maxdest-1 ) {
        c=decodeBocu1(&rx, p[i++]);
        if(c<-1) {
			break;
        }
        if(c>=0) {
			*dest++	= c;
        }
    }
	*dest	= '\0';
    return sLength;
}

#if	defined(UNICODE)
// PT[`(UTF-16)
int SearchString( WCHAR* textstr, int textlen, WCHAR* keyword, int keywordlen )
{
	WCHAR *wbp;
	for ( wbp = textstr; wbp<=textstr+textlen-keywordlen; ++wbp ) {
		if ( _tcsncmp( wbp, keyword, keywordlen ) == 0 ) {
			return wbp - textstr;
		}
	}
	return -1;
}
#endif

// PT[`(oCg)
int SearchString( byte* textstr, int textlen, byte* keyword, int keywordlen )
{
	byte *bp;
	for ( bp = textstr; bp<=textstr+textlen-keywordlen; ++bp ) {
		if ( strncmp( (char*)bp, (char*)keyword, keywordlen ) == 0 ) {
			return bp - textstr;
		}
	}
	return -1;
}

#define	_BM_SEARCH	1	// SBM@Ŏs

#if	defined(_BM_SEARCH)

#define	CSIZE	256		// byte PʂŔrs

// ړʃe[u̍쐬
//	byte bm_table[CSIZE];
void make_bm_table( byte *pattern,	// 
					int size ,		// 
					byte *bm_table	// ړʃe[u(z񒷂CSIZE)
					)
{
	int i;
	for( i=0; i<CSIZE; i++ )
		bm_table[i] = size;
	size -= 1;
	for ( i=0; i<size; ++i ) {
		bm_table[ pattern[i] ] = size - i;
	}
}

// BM@ɂ錟
int bm_search(	byte*buffer,	// Ώە
				int bufLen,		// A
				byte*pattern,	// 
				int patlen,		// A
				byte *bm_table	// ړʃe[u make_bm_table() ō쐬
				)
{
	int	row = 1;	// sFs+1
	long rowPos = 0;	// sJEgpCfbNX
	long BOLPos = 0;		// vs̍s
	int nMatch = 0;	// v

//	if ( bufLen<=0 )
//		return -1;
	ASSERT( bufLen>0 );
	//GW
	int i;
	unsigned char c, tail;

	if ( pattern == NULL )
		return -1;
	tail = pattern[ patlen -1 ];					// Ō̕
	int Index = 0;

	if( patlen == 1 ) {			// ̒1̏ꍇ
		while(1) {
			if( Index > bufLen ) {
				return -1;
			}
			if( (buffer[Index] ) == tail ) {
				return Index;
			}
			Index++;
		}
	}
	else {						// ̒2ȏ̏ꍇ
		Index += (patlen-1);	// Jn|C^̍Ō̕ɃZbg

		while(1) {								// Jn
			if( Index > bufLen ) {			//Ȃ
				return -1;
			}
			c = buffer[Index];
			if( c == tail ) {
				for( i=1; i<patlen; i++ ) {
					if( buffer[ Index-i ] != pattern[ (patlen-1)-i ] ) {
						Index++;
						goto NO_MATCH;
					}
				}
				return Index;					//!!
			}
			else	Index += bm_table[ (int)c ];
NO_MATCH:;
		}
	}
	return -1;
}

#endif



//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CPDicReader::CPDicReader()
{
	m_fp	= NULL;
	m_pdic_ver	= 0;
	m_pIndex	= NULL;
	m_pData	= NULL;

	// \
	m_hitent		= NULL;	// v
	m_numhit		= 0;	// qbg
	m_title_pool	= NULL;	// Ɉvõv[
	m_max_title_pool= 0;	// m_title_pool̊蓖ăTCY
	m_title_len		= 0;	// m_title_pool̍ŏIʒu
	m_bOpened		= 0;
}

CPDicReader::~CPDicReader()
{
	Close();
}

static char PDIC_MAGIC_STR[]	= "=============== Dictionary for PDIC ===============";

// PDIC J
//	0	
//	-1	s
int	CPDicReader::Open( LPCTSTR pszFilePath )
{
	ASSERT( pszFilePath );

	byte buffer[PDIC_HEADER_256];	// wb_擪256

	if ( m_bOpened ) 
		return -1;

	// PDICt@Copen
	m_fp	= _tfopen( pszFilePath, _T("rb") );
	if ( !m_fp ) {
		return -1;
	}

	// wb_ǂ
	if ( fread( &buffer, 1,PDIC_HEADER_256, m_fp ) != PDIC_HEADER_256 ) {
		goto header_error;
	}
	ASSERT(sizeof(m_header) == PDIC_HEADER_256);
	memcpy( &m_header, buffer, PDIC_HEADER_256 );
	// error check
	m_pdic_ver = m_header.version >> 8;
	if ( m_pdic_ver < 4
		|| m_header.header_size	== 0
		|| m_header.header_size	> PDIC_MAX_HEADER_LEN
		|| m_header.block_size == 0 
		|| m_header.block_size > PDIC_MAX_BLKLEN
		) {
		goto header_error;
	}
	if ( memcmp( (char*)PDIC_MAGIC_STR, (char*)m_header.headername+0x0D, sizeof(PDIC_MAGIC_STR)-1 )==0	// PDIC/Unicode
	  || memcmp( (char*)PDIC_MAGIC_STR, (char*)m_header.headername+0x18, sizeof(PDIC_MAGIC_STR)-1 )==0	// PDIC for win32
	  ) {
		;
	}
	else {
		goto header_error;
	}

	//	o[Wɂčڂ̃ItZbgقȂ̂ŁAsB
	//	ver.5 肵Ă̂ŁAver.5̏ꍇ͒Ȃ
	//	ȂAnindex,nblock͎gpAnindex2,nblock2g
	switch ( m_pdic_ver ) {
	case 2:
		m_header.nindex2	=	m_header.nindex;
		m_header.nblock2	=	m_header.nblock;
		m_header.extheader	=	0;
		m_header.index_blkbit	= 0;	// 16 bit
		m_header.empty_block2	= m_header.empty_block;
		break;
	case 3:
		m_header.nindex2	=	m_header.nindex;
		m_header.nblock2	=	m_header.nblock;
		m_header.extheader	=	0;
		m_header.index_blkbit	= 0;	// 16 bit
		m_header.block_size	*=16;	// NEWDIC2̏ꍇA16ŊĂ
		m_header.empty_block2	= m_header.empty_block;
		break;
	case 4:
		m_header.olenumber	=	LFOURBYTEUINT(buffer+167);
		m_header.os			=	buffer[171];
		m_header.extheader	=	LFOURBYTEUINT(buffer+182);	
		m_header.empty_block2	= LFOURBYTEUINT(buffer+186);
		m_header.nindex2	=	LFOURBYTEUINT(buffer+190);
		m_header.nblock2	=	LFOURBYTEUINT(buffer+194);
		m_header.index_blkbit	= buffer[198];
		m_header.update_count	= LFOURBYTEUINT(buffer+208);
		break;
	case 5:
		break;
	}
	m_pIndex	= new CPDicIndex( m_fp, &m_header );
	m_pData		= new CPDicData( m_fp, &m_header );

	m_bOpened	= 1;
	return 0;

header_error:
	Close();
	return -1;
}

// PDIC ̃t@Cnĥݍopen
//	0	
//	-1	s
int	CPDicReader::ReOpen( LPCTSTR pszFilePath )
{
	ASSERT( pszFilePath );

	if ( !m_bOpened || !m_fp ) 
		return -1;

	fclose( m_fp );

	// PDICt@Copen
	m_fp	= _tfopen( pszFilePath, _T("rb") );
	if ( !m_fp ) {
		return -1;
	}
	if ( m_pData )	m_pData->m_fp	= m_fp;
	if ( m_pIndex )	m_pIndex->m_fp	= m_fp;

	return 0;

}

// PDIC ̎gpI
void CPDicReader::Close()
{
	if ( m_fp ) {
		fclose( m_fp );
		m_fp	= NULL;
	}

	if ( m_pIndex ) {
		delete m_pIndex;
		m_pIndex	= NULL;
	}

	if ( m_pData ) {
		delete m_pData;
		m_pData	= NULL;
	}

	// \
	ClearHitEnt();

	m_bOpened	= 0;
}

void CPDicReader::ClearHitEnt()
{
	//	ʂNA
	if ( m_hitent ) {
		free( m_hitent );
		m_hitent	= NULL;
	}
	if ( m_title_pool ) {
		free( m_title_pool );
		m_title_pool	= NULL;
	}
	m_numhit		= 0;	// qbg
	m_max_hitent	= 0;	// m_hitent[]̊TCY

	m_max_title_pool	= 0;	// m_title_pool̊TCY
	m_title_len		= 0;	// m_title_pool̍ŏIʒu

}

// L[[hs
//	߂lFv	0Ȃsv
int CPDicReader::SearchWord( LPCTSTR keyword,	// L[[h
							int bExact,		// T:Sv
							int maxHit,		// v; 0 ͖
							int *over		// 𒴂ꍇA1ݒ
							)
{
	ASSERT( keyword );

	unsigned long	_datablk;	// f[^ubN̕ubNԍ
	byte _titlestr[PDIC_MAX_TITLE+1];	// CfbNXɋL^ꂽo
#if	defined(UNICODE)
	TCHAR w_titlestr[PDIC_MAX_TITLE+1];
	byte mb_keyword[PDIC_MAX_TITLE+1];
	int nChar;
#endif
	int	keywordlen;

	int _titlelen,_hoffs,_honbunlen,_yoffs,_yoreilen,_poffs,_phoneticlen,_level;
	m_numhit	= 0;
	*over	= false;
//	if ( maxHit == 0 ) {
//		maxHit	= PDIC_MAX_HIT;
//	}

	//	ʂNA
	ClearHitEnt();

	//	(1)擪̃CfbNXԍ
	long 	_idxno	= m_pIndex->BSearchIndex( keyword );

	//	(2)CfbNXubNƂɃf[^ubNɓǂ
	int	_over	= 0;
	int	status;

#if	defined(UNICODE)
	if ( m_header.dictype & 0x08 ) {	// BOCU1
		keywordlen	= _tcslen(keyword);
	}
	else {
		nChar = ::WideCharToMultiByte( _KANJI_CP, NULL, keyword, _tcslen(keyword), 
					(LPSTR)mb_keyword, PDIC_MAX_TITLE, NULL, NULL);	// ϊ(ShiftJIS)
		mb_keyword[nChar]	= '\0';
		keywordlen	= nChar;
	}
#else
	keywordlen	= _tcslen(keyword);
#endif

	// ̃CfbNXǂ
	while ( !_over 
		&& _idxno<m_header.nindex2 
		&& m_pIndex->ReadRec( _idxno, &_datablk, (byte*)_titlestr, &_titlelen ) == 0 ) {

		////////////////////////////////////////////////////
		// ȉdicorder == 0 (R[h)̏ꍇp
		////////////////////////////////////////////////////
#if	defined(UNICODE)
		//	Unicode̎ABOCU->UCS2ɕϊr
		if ( m_header.dictype & 0x08 ) {	// BOCU1
			BOCU1_decode( _titlestr, _titlelen, w_titlestr, PDIC_MAX_TITLE );
			status = _tcsncmp( w_titlestr, keyword, keywordlen ) ;
		}
		else {
			//	UnicodȅꍇAShiftJISŔr
			status = strncmp( (char*)_titlestr, (char*)mb_keyword, keywordlen ) ;
		}
#else
		status = strncmp( (char*)_titlestr, keyword, keywordlen ) ;
#endif
		if ( status > 0 ) {	// L[[h𒴂̂ŒTI
			_over	= 1;
			break;
		}
		// _datablkn܂f[^ubN(AubN)ǂ
		if ( m_pData->ReadBlks( _datablk ) == -1 ) {
			break;
		}
		int	_num	= 0;
		// AubÑf[^R[hǂ
		while ( !_over ) {
			int	_recOffs	= m_pData->GetOffs();
			if ( m_pData->ReadRec( (byte*)_titlestr, &_titlelen,
								&_hoffs, &_honbunlen,
								&_yoffs, &_yoreilen,
								&_poffs, &_phoneticlen, &_level ) != 0 ) {
				break;
			}
			int	_strlen;
	#if	defined(UNICODE)
			//	Unicode̎ABOCU->UCS2ɕϊr
			if ( m_header.dictype & 0x08 ) {	// BOCU1
				BOCU1_decode( _titlestr, _titlelen, w_titlestr, PDIC_MAX_TITLE );
				// PDIC/Unicode Ή ; \t\
				if ( bExact && m_pdic_ver >= 6 ) {
					int ix;
					for ( ix=0;ix<PDIC_MAX_TITLE;++ix ) {
						if ( w_titlestr[ix] == 0x09 ) {
							w_titlestr[ix]	= 0;
							break;
						}
					}
				}
				_strlen	= _tcslen( w_titlestr );
				status = _tcsncmp( w_titlestr, keyword, keywordlen ) ;
			}
			else {
				//	UnicodȅꍇAShiftJISŔr
				_strlen	= _titlelen;
				status = strncmp( (char*)_titlestr, (char*)mb_keyword, keywordlen ) ;
			}
	#else
			_strlen	= _titlelen;
			status = strncmp( (char*)_titlestr, keyword, keywordlen ) ;
	#endif
			if ( status == 0 ) {	// 
				//	!bExact ͈̎v(Ov)
				//	bExact̎_titlestr̒keywordlenɓƂv
				if ( !bExact || bExact && _strlen == keywordlen ) {
					//	Ɉvf[^͌ʃe[uɓo^

					//	ʃe[uȂAŊ蓖
					//	TCYsꍇAg
					if ( !m_hitent ) {
						m_max_hitent	= MAX_PDIC_HITENT;
						m_hitent	= (PDIC_HITENT*)malloc( m_max_hitent * sizeof(PDIC_HITENT) );
					}
					else if ( m_max_hitent <= m_numhit ) {
						m_max_hitent	+= MAX_PDIC_HITENT;
						m_hitent	= (PDIC_HITENT*)realloc( m_hitent, m_max_hitent * sizeof(PDIC_HITENT) );
					}
					//	óAov[ɕۑ
					if ( !m_title_pool ) {
						m_max_title_pool	= MAX_PDIC_POOL;
						m_title_pool	= (byte*)malloc( m_max_title_pool * sizeof(byte) );
					}
					else if ( m_max_title_pool <= m_title_len+_titlelen+1 ) {
						m_max_title_pool	+= MAX_PDIC_POOL;
						m_title_pool	= (byte*)realloc( m_title_pool, m_max_title_pool * sizeof(byte) );
					}

					//	ʃe[uɓo^
					memset( &m_hitent[m_numhit] ,0, sizeof(PDIC_HITENT) );
					m_hitent[m_numhit].indexno		= _idxno;
					m_hitent[m_numhit].blkno		= _datablk;
					m_hitent[m_numhit].titleoffs	= m_title_len;
					m_hitent[m_numhit].titlelen		= _titlelen;
					m_hitent[m_numhit].hoffs		= _hoffs;
					m_hitent[m_numhit].honbunlen	= _honbunlen;
					m_hitent[m_numhit].yoffs		= _yoffs;
					m_hitent[m_numhit].yoreilen		= _yoreilen;
					m_hitent[m_numhit].poffs		= _poffs;
					m_hitent[m_numhit].phoneticlen	= _phoneticlen;
					m_hitent[m_numhit].level		= _level;
					m_hitent[m_numhit].recOffs		= _recOffs;
//					m_hitent[m_numhit].num			= _num;

					memcpy( m_title_pool+m_title_len,_titlestr,_titlelen );
					m_title_len	+= _titlelen;
					m_title_pool[m_title_len++]	= '\0';

					++m_numhit;
				}
				if ( bExact && _strlen > keywordlen ) {
					_over	= 1;
				}
			}
			else if ( status < 0 ) {	//
				//	OȂ̂ŁAXLbv
			}
			else if ( status > 0 ) {
				// L[[h𒴂̂ŒTI
				_over	= 1;
				break;
			}
			++_num;

			//	ݒ肳ĂČꍇ́A~
			if ( maxHit>0 && m_numhit>=(unsigned long)maxHit ) {
				_over	= 1;
				*over	= true;
			}
		}
		++_idxno;

	}
	return m_numhit;
}

// w肵CfbNXԍ̎f[^ubNSČ
int CPDicReader::SearchAbs( unsigned long idxno )
{
	unsigned long	_datablk;	// f[^ubN̕ubNԍ
	byte _titlestr[PDIC_MAX_TITLE+1];	// CfbNXɋL^ꂽo

	int _titlelen,_hoffs,_honbunlen,_yoffs,_yoreilen,_poffs,_phoneticlen,_level;

	//	ʂNA
	ClearHitEnt();

	//	CfbNXubNƂɃf[^ubNɓǂ
	int	_over	= 0;

	// ̃CfbNXǂ
	if ( idxno<(unsigned long)m_header.nindex2 
		&& m_pIndex->ReadRec( idxno, &_datablk, (byte*)_titlestr, &_titlelen ) == 0
		&& m_pData->ReadBlks( _datablk ) == 0 ) {

		int	_num	= 0;
		// AubÑf[^R[hǂ
		while ( !_over ) {
			int	_recOffs	= m_pData->GetOffs();
			if ( m_pData->ReadRec( (byte*)_titlestr, &_titlelen,
								&_hoffs, &_honbunlen,
								&_yoffs, &_yoreilen,
								&_poffs, &_phoneticlen, &_level ) != 0 ) {
				break;
			}


			//	ʃe[uȂAŊ蓖
			//	TCYsꍇAg
			if ( !m_hitent ) {
				m_max_hitent	= MAX_PDIC_HITENT;
				m_hitent	= (PDIC_HITENT*)malloc( m_max_hitent * sizeof(PDIC_HITENT) );
			}
			else if ( m_max_hitent <= m_numhit ) {
				m_max_hitent	+= MAX_PDIC_HITENT;
				m_hitent	= (PDIC_HITENT*)realloc( m_hitent, m_max_hitent * sizeof(PDIC_HITENT) );
			}
			//	óAov[ɕۑ
			if ( !m_title_pool ) {
				m_max_title_pool	= MAX_PDIC_POOL;
				m_title_pool	= (byte*)malloc( m_max_title_pool * sizeof(byte) );
			}
			else if ( m_max_title_pool <= m_title_len+_titlelen+1 ) {
				m_max_title_pool	+= MAX_PDIC_POOL;
				m_title_pool	= (byte*)realloc( m_title_pool, m_max_title_pool * sizeof(byte) );
			}

			//	ʃe[uɓo^
			memset( &m_hitent[m_numhit] ,0, sizeof(PDIC_HITENT) );
			m_hitent[m_numhit].indexno		= idxno;
			m_hitent[m_numhit].blkno		= _datablk;
			m_hitent[m_numhit].titleoffs	= m_title_len;
			m_hitent[m_numhit].titlelen		= _titlelen;
			m_hitent[m_numhit].hoffs		= _hoffs;
			m_hitent[m_numhit].honbunlen	= _honbunlen;
			m_hitent[m_numhit].yoffs		= _yoffs;
			m_hitent[m_numhit].yoreilen		= _yoreilen;
			m_hitent[m_numhit].poffs		= _poffs;
			m_hitent[m_numhit].phoneticlen	= _phoneticlen;
			m_hitent[m_numhit].level		= _level;
			m_hitent[m_numhit].recOffs		= _recOffs;
//			m_hitent[m_numhit].num			= _num;

			memcpy( m_title_pool+m_title_len,_titlestr,_titlelen );
			m_title_len	+= _titlelen;
			m_title_pool[m_title_len++]	= '\0';

			++m_numhit;

			++_num;
		}
	}
	return m_numhit;
}

#if defined(_DEF_RELEASECONTROL)
void ReleaseControl();
#else
// VXeɕԂ
void ReleaseControl()
{
		MSG message;
		if ( ::PeekMessage(&message,NULL,0,0,PM_REMOVE)) {
			::TranslateMessage(&message);
			::DispatchMessage(&message);
		}
		Sleep( 0 );	// D揇ʂ̃XbhΏ
}
#endif

// S
int CPDicReader::SearchFullText(
				LPCTSTR keyword,	// L[[h
				int maxHit,		// v; 0 ͖
				int *over,		// 𒴂ꍇA1ݒ
				short *bAbort,	// ftO
				void ( *EchoCallback )(LPVOID pParam,int count, int blks, int nRead ),	// \R[obN
				LPVOID pParam,	// R[obN֐Ɉncaller̃IuWFNg
				int flag	// ΏۃtO	PDIC_S_TITLE | PDIC_S_HONBUN | PDIC_S_YOREI
		)	
{
	ASSERT( keyword );

	byte _titlestr[PDIC_MAX_TITLE+1];	// CfbNXɋL^ꂽo
#if	defined(UNICODE)
	TCHAR w_honbun[PDIC_MAX_HONBUN+1];
	TCHAR w_titlestr[PDIC_MAX_TITLE+1];
	byte mb_keyword[PDIC_MAX_TITLE+1];
	int nChar;
	int	_strlen;
#endif
	int	keywordlen;

	int _titlelen,_hoffs,_honbunlen,_yoffs,_yoreilen,_poffs,_phoneticlen,_level;
	m_numhit	= 0;
	*over	= false;
//	if ( maxHit == 0 ) {
//		maxHit	= PDIC_MAX_HIT;
//	}

	//	ʂNA
	ClearHitEnt();

	//	(1)擪ɈʒuÂ
	m_seq_idxno	= 0;

	//	(2)CfbNXubNƂɃf[^ubNɓǂ
	int	_over	= 0;
	int	status;

#if	defined(UNICODE)
	if ( m_header.dictype & 0x08 ) {	// BOCU1
		keywordlen	= _tcslen(keyword);
	}
	else {
		nChar = ::WideCharToMultiByte( _KANJI_CP, NULL, keyword, _tcslen(keyword), 
					(LPSTR)mb_keyword, PDIC_MAX_TITLE, NULL, NULL);	// ϊ(ShiftJIS)
		mb_keyword[nChar]	= '\0';
		keywordlen	= nChar;
	}
#else
	keywordlen	= _tcslen(keyword);
#endif

	// ̃CfbNXǂ
	while ( !_over 
		&& m_seq_idxno<(unsigned long)m_header.nindex2 
		&& m_pIndex->ReadRec( m_seq_idxno, &m_seq_datablk, (byte*)_titlestr, &_titlelen ) == 0 ) {

		// _datablkn܂f[^ubN(AubN)ǂ
		if ( m_pData->ReadBlks( m_seq_datablk ) == -1 ) {
			break;
		}
		int	_num	= 0;
		// AubÑf[^R[hǂ
		while ( !_over ) {
			int	_recOffs	= m_pData->GetOffs();
			// ̃R[hǂ
			if ( m_pData->ReadRec( (byte*)_titlestr, &_titlelen, 
									&_hoffs, &_honbunlen,
									&_yoffs, &_yoreilen,
									&_poffs, &_phoneticlen, &_level)!= 0 ) {
				//	f[^ubN̍Ō̃R[h̏ꍇÃf[^ubNǂ

				// CfbNXÃf[^ubN𓾂
				++m_seq_idxno;
				if ( m_pIndex->ReadRec( m_seq_idxno, &m_seq_datablk, (byte*)_titlestr,&_titlelen ) != 0 ) {
					break;
				}
				// ̃f[^ubNǂ
				if ( m_pData->ReadBlks( m_seq_datablk ) != 0 ) {
					break;
				}
				// ̃R[hǂ
				_recOffs	= m_pData->GetOffs();
				if ( m_pData->ReadRec( (byte*)_titlestr, &_titlelen,
									&_hoffs, &_honbunlen,
									&_yoffs, &_yoreilen,
									&_poffs, &_phoneticlen, &_level )!= 0 ) {
					break;
				}
			}
			byte* p = m_pData->GetBuffer();
			if ( !p ) 
				break;

			if ( EchoCallback ) EchoCallback( pParam, m_numhit, m_header.nindex2,m_seq_idxno );
			ReleaseControl();
			if ( *bAbort ) {
				_over	= 1;
				break;
			}

#if	defined(_BM_SEARCH)
			byte bm_table[CSIZE];
	#if	defined(UNICODE)
			if ( m_header.dictype & 0x08 ) {	// BOCU1
				make_bm_table( (byte*)keyword, keywordlen*sizeof(WCHAR) ,bm_table);
			}
			else {
				make_bm_table( mb_keyword, keywordlen ,bm_table);
			}
	#else
			make_bm_table( (byte*)keyword, keywordlen , bm_table);
	#endif
#endif
			status	= -1;	// v0

			// (1)oS
			if ( flag & PDIC_S_TITLE ) {
#if	defined(UNICODE)
				//	Unicode̎ABOCU->UCS2ɕϊr
				if ( m_header.dictype & 0x08 ) {	// BOCU1
					BOCU1_decode( _titlestr, _titlelen, w_titlestr, PDIC_MAX_TITLE );
					_strlen	= _tcslen( w_titlestr );
	#if	defined(_BM_SEARCH)
					if ( bm_search( (byte*)w_titlestr,_strlen*sizeof(WCHAR), (byte*)keyword, keywordlen*sizeof(WCHAR),bm_table ) != -1 ) {
	#else
					if ( SearchString( w_titlestr,_strlen, (WCHAR*)keyword, keywordlen ) != -1 ) {
	#endif
						status	= 0;
					}
				}
				else {
					//	UnicodȅꍇAShiftJISŔr
	#if	defined(_BM_SEARCH)
					if ( bm_search( _titlestr,_titlelen, mb_keyword, keywordlen,bm_table ) != -1 ) {
	#else
					if ( SearchString( _titlestr,_titlelen, mb_keyword, keywordlen ) != -1 ) {
	#endif
						status	= 0;
					}
				}
#else
	#if	defined(_BM_SEARCH)
				if ( bm_search( _titlestr,_titlelen, (byte*)keyword, keywordlen,bm_table ) != -1 ) {
	#else
				if ( SearchString( _titlestr,_titlelen, keyword, keywordlen ) != -1 ) {
	#endif
					status	= 0;
				}
#endif
			}
			// (2){S
			if ( status != 0 
				&& ( flag & PDIC_S_HONBUN )
				&& _honbunlen>0 ) {	// 
		#if	defined(UNICODE)
				//	Unicode̎ABOCU->UCS2ɕϊr
				if ( m_header.dictype & 0x08 ) {	// BOCU1
					BOCU1_decode( p+_hoffs, _honbunlen, w_honbun, PDIC_MAX_HONBUN );
					_strlen	= _tcslen( w_honbun );
					ASSERT(_strlen<PDIC_MAX_HONBUN);
#if	defined(_BM_SEARCH)
					if ( bm_search( (byte*)w_honbun,_strlen*sizeof(WCHAR), (byte*)keyword, keywordlen*sizeof(WCHAR),bm_table ) != -1 ) {
#else
					if ( SearchString( w_honbun,_strlen, (WCHAR*)keyword, keywordlen ) != -1 ) {
#endif
						status	= 0;
					}
				}
				else {
					//	UnicodȅꍇAShiftJISŔr
#if	defined(_BM_SEARCH)
					if ( bm_search( p+_hoffs,_honbunlen, mb_keyword, keywordlen,bm_table ) != -1 ) {
#else
					if ( SearchString( p+_hoffs,_honbunlen, mb_keyword, keywordlen ) != -1 ) {
#endif
						status	= 0;
					}
				}
		#else
#if	defined(_BM_SEARCH)
				if ( bm_search( p+_hoffs,_honbunlen, (byte*)keyword, keywordlen,bm_table ) != -1 ) {
#else
				if ( SearchString( p+_hoffs,_honbunlen, keyword, keywordlen ) != -1 ) {
#endif
					status	= 0;
				}
		#endif
			}
			// (3)pS
			if ( status != 0
				&& ( flag & PDIC_S_YOREI )
				&& _yoreilen>0 ) {	// 
		#if	defined(UNICODE)
				//	Unicode̎ABOCU->UCS2ɕϊr
				if ( m_header.dictype & 0x08 ) {	// BOCU1
					BOCU1_decode( p+_yoffs, _yoreilen, w_honbun, PDIC_MAX_HONBUN );
					_strlen	= _tcslen( w_honbun );
					ASSERT(_strlen<PDIC_MAX_HONBUN);
#if	defined(_BM_SEARCH)
					if ( bm_search( (byte*)w_honbun,_strlen*sizeof(WCHAR), (byte*)keyword, keywordlen*sizeof(WCHAR),bm_table ) != -1 ) {
#else
					if ( SearchString( w_honbun,_strlen, (WCHAR*)keyword, keywordlen ) != -1 ) {
#endif
						status	= 0;
					}
				}
				else {
					//	UnicodȅꍇAShiftJISŔr
#if	defined(_BM_SEARCH)
					if ( bm_search( p+_yoffs,_yoreilen, mb_keyword, keywordlen,bm_table ) != -1 ) {
#else
					if ( SearchString( p+_yoffs,_yoreilen, mb_keyword, keywordlen ) != -1 ) {
#endif
						status	= 0;
					}
				}
		#else
#if	defined(_BM_SEARCH)
				if ( bm_search( p+_yoffs,_yoreilen, (byte*)keyword, keywordlen,bm_table ) != -1 ) {
#else
				if ( SearchString( p+_yoffs,_yoreilen, keyword, keywordlen ) != -1 ) {
#endif
					status	= 0;
				}
		#endif
			}

			//	Ɉvf[^͌ʃe[uɓo^
			if ( status == 0 ) {	// 

				//	ʃe[uȂAŊ蓖
				//	TCYsꍇAg
				if ( !m_hitent ) {
					m_max_hitent	= MAX_PDIC_HITENT;
					m_hitent	= (PDIC_HITENT*)malloc( m_max_hitent * sizeof(PDIC_HITENT) );
				}
				else if ( m_max_hitent <= m_numhit ) {
					m_max_hitent	+= MAX_PDIC_HITENT;
					m_hitent	= (PDIC_HITENT*)realloc( m_hitent, m_max_hitent * sizeof(PDIC_HITENT) );
				}
				//	óAov[ɕۑ
				if ( !m_title_pool ) {
					m_max_title_pool	= MAX_PDIC_POOL;
					m_title_pool	= (byte*)malloc( m_max_title_pool * sizeof(byte) );
				}
				else if ( m_max_title_pool <= m_title_len+_titlelen+1 ) {
					m_max_title_pool	+= MAX_PDIC_POOL;
					m_title_pool	= (byte*)realloc( m_title_pool, m_max_title_pool * sizeof(byte) );
				}

				//	ʃe[uɓo^
				memset( &m_hitent[m_numhit] ,0, sizeof(PDIC_HITENT) );
				m_hitent[m_numhit].indexno		= m_seq_idxno;
				m_hitent[m_numhit].blkno		= m_seq_datablk;
				m_hitent[m_numhit].titleoffs	= m_title_len;
				m_hitent[m_numhit].titlelen		= _titlelen;
				m_hitent[m_numhit].hoffs		= _hoffs;
				m_hitent[m_numhit].honbunlen	= _honbunlen;
				m_hitent[m_numhit].yoffs		= _yoffs;
				m_hitent[m_numhit].yoreilen		= _yoreilen;
				m_hitent[m_numhit].poffs		= _poffs;
				m_hitent[m_numhit].phoneticlen	= _phoneticlen;
				m_hitent[m_numhit].level		= _level;
				m_hitent[m_numhit].recOffs		= _recOffs;

				memcpy( m_title_pool+m_title_len,_titlestr,_titlelen );
				m_title_len	+= _titlelen;
				m_title_pool[m_title_len++]	= '\0';

				++m_numhit;
			}
			++_num;

			//	ݒ肳ĂČꍇ́A~
			if ( maxHit>0 && m_numhit>=(unsigned long)maxHit ) {
				_over	= 1;
				*over	= true;
			}
		}
		++m_seq_idxno;

	}
	return m_numhit;

}



//	0	
//	-1	s
int CPDicReader::GetHitEnt( PDIC_HITENT **hit_list, int *numhit )
{
	if ( !m_hitent ) {
		*numhit	= 0;
		return -1;
	}
	*hit_list	= m_hitent;
	*numhit		= m_numhit;

	return 0;
}

// vԂ
int CPDicReader::GetHitCount()
{
	return m_numhit;
}

byte* CPDicReader::GetTextPool()
{
	return m_title_pool;
}

int CPDicReader::GetMaxText()
{
	return m_title_len;
}

unsigned long CPDicReader::GetOffs()
{
	return m_pData->GetOffs();
}

unsigned long CPDicReader::GetBlkNo()	// ݂̘AubN擪ԍ
{
	return m_pData->GetBlkNo();
}

unsigned long	CPDicReader::GetIndexNo()			// ݂̃CfbNXԍ
{
	return m_seq_idxno;
}

NEWDIC3_5 *CPDicReader::GetHeader()	// PDIC̃wb_(Ver5`)
{
	return &m_header;
}

// PDIC̃o[Wԍ
int CPDicReader::GetPDICVer()
{
	return m_pdic_ver;
}

// numԖڂ̌ʂ擾B
//	Ǐö́AĂяoŊmۂB
//		o	  248
//				 3000
//		p		20000
//	0	
//	-1	s
int CPDicReader::ReadResult( int num,		//	w肵ԍ̌ʂ擾
							LPTSTR title,	//	o(unicodȅꍇAUCS-2)
							LPTSTR honbun,	//	(unicodȅꍇAUCS-2)
							int maxhonbun, 	//	̗̈̍ő咷(max:3000)
							LPTSTR yorei,	//	p(unicodȅꍇAUCS-2)
							int maxyorei, 	//	p̗̈̍ő咷(max:20000)
							LPTSTR phonetic,	//	(unicodȅꍇAUCS-2)
							int maxphonetic,	//	̗̈̍ő咷(max:1000)
							int*level,			// Pꃌx
							unsigned short (*phoneticUniMap)[256][2] 
							)
{
	ASSERT ( num>=0 && num<(int)m_numhit ) ;
	if ( num<0 || num>=(int)m_numhit ) 
		return -1;
	if ( !m_hitent ) 
		return -1;
	if ( !m_title_pool ) 
		return -1;
	return ReadResultEnt( &m_hitent[num], m_title_pool,
							 title,	//	o(unicodȅꍇAUCS-2)
							 honbun,	//	(unicodȅꍇAUCS-2)
							 maxhonbun, 	//	̗̈̍ő咷(max:3000)
							 yorei,	//	p(unicodȅꍇAUCS-2)
							 maxyorei, 	//	p̗̈̍ő咷(max:20000)
							 phonetic,	//	(unicodȅꍇAUCS-2)
							 maxphonetic,	//	̗̈̍ő咷(max:1000)
							level,			// Pꃌx
							phoneticUniMap
							);
}

//	Ǐö́AĂяoŊmۂB
//		o	  248
//				 3000
//		p		20000
//	0	
//	-1	s
int CPDicReader::ReadResultEnt( PDIC_HITENT*pHitEnt,
							byte*pTitlePool,
							LPTSTR title,	//	o(unicodȅꍇAUCS-2)
							LPTSTR honbun,	//	(unicodȅꍇAUCS-2)
							int maxhonbun, 	//	̗̈̍ő咷(max:3000)
							LPTSTR yorei,	//	p(unicodȅꍇAUCS-2)
							int maxyorei, 	//	p̗̈̍ő咷(max:20000)
							LPTSTR phonetic,	//	(unicodȅꍇAUCS-2)
							int maxphonetic,	//	̗̈̍ő咷(max:1000)
							int*level,			// Pꃌx
							unsigned short (*phoneticUniMap)[256][2] 
							)
{
	ASSERT( title );
	ASSERT( honbun );
	ASSERT( yorei );

	title[0]	= '\0';
	honbun[0]	= '\0';
	yorei[0]	= '\0';
	phonetic[0]	= '\0';

	if ( m_pData->ReadBlks( pHitEnt->blkno ) != 0 ) 
		return -1;
	byte* p = m_pData->GetBuffer();
	if ( !p ) 
		return -1;

#if	defined(UNICODE)
	//	UnicodȅꍇABOCU1->UCS2
	if ( m_header.dictype & 0x08 ) {	// BOCU1
		BOCU1_decode( pTitlePool+pHitEnt->titleoffs,pHitEnt->titlelen, title, PDIC_MAX_TITLE );
		BOCU1_decode( p+pHitEnt->hoffs,pHitEnt->honbunlen, honbun, maxhonbun );
		if ( pHitEnt->yoreilen>0 ) {
			BOCU1_decode( p+pHitEnt->yoffs,pHitEnt->yoreilen, yorei, maxyorei );
		}
		if ( pHitEnt->phoneticlen>0 ) {
			if ( phoneticUniMap ) {
				TCHAR tmp_phonetic[PDIC_MAX_PHONETIC+1];
				BOCU1_decode( p+pHitEnt->poffs,pHitEnt->phoneticlen, tmp_phonetic, maxphonetic );
				MapPhoneticUni( tmp_phonetic,_tcslen(tmp_phonetic), phonetic, maxphonetic,phoneticUniMap );
			}
			else {
				BOCU1_decode( p+pHitEnt->poffs,pHitEnt->phoneticlen, phonetic, maxphonetic );
			}
		}
	}
	else {
		//	UnicodȅꍇAShiftJIS->UCS2
		int nChar = ::MultiByteToWideChar(
			  _KANJI_CP,	// R[hy[W	
			  0,			// ̎ނw肷tO
			  (char*)pTitlePool+pHitEnt->titleoffs,	// }bṽAhX
			  pHitEnt->titlelen,	// }bṽoCg
			  title,		// }bv惏Chobt@̃AhX
			  PDIC_MAX_TITLE	// obt@̃TCY
		);
		title[nChar]	= 0;

		nChar = ::MultiByteToWideChar(
			  _KANJI_CP,	// R[hy[W	
			  0,			// ̎ނw肷tO
			  (char*)p+pHitEnt->hoffs,	// }bṽAhX
			  pHitEnt->honbunlen,	// }bṽoCg
			  honbun,		// }bv惏Chobt@̃AhX
			  maxhonbun	// obt@̃TCY
		);
		honbun[nChar]	= 0;

		if ( pHitEnt->yoreilen>0 ) {
			nChar = ::MultiByteToWideChar(
				  _KANJI_CP,	// R[hy[W	
				  0,			// ̎ނw肷tO
				  (char*)p+pHitEnt->yoffs,	// }bṽAhX
				  pHitEnt->yoreilen,	// }bṽoCg
				  yorei,		// }bv惏Chobt@̃AhX
				  maxyorei	// obt@̃TCY
			);
			yorei[nChar]	= 0;

		}
		if ( pHitEnt->phoneticlen>0 ) {

			if ( phoneticUniMap ) {
				MapPhoneticUni( p+pHitEnt->poffs,pHitEnt->phoneticlen, phonetic, maxphonetic,phoneticUniMap );
			}
			else {
				nChar = ::MultiByteToWideChar(
					  _KANJI_CP,	// R[hy[W	
					  0,			// ̎ނw肷tO
					  (char*)p+pHitEnt->poffs,	// }bṽAhX
					  pHitEnt->phoneticlen,	// }bṽoCg
					  phonetic,		// }bv惏Chobt@̃AhX
					  maxphonetic	// obt@̃TCY
				);
				phonetic[nChar]	= 0;
			}
		}

	}
#else
	strcpy(  title, (LPTSTR)pTitlePool+pHitEnt->titleoffs );
	int	datasize	= min( maxhonbun, pHitEnt->honbunlen );
	memcpy( honbun, p+pHitEnt->hoffs, datasize );
	honbun[ datasize ]	=  '\0';

	if ( pHitEnt->yoreilen>0 ) {
		datasize	= min( maxyorei, pHitEnt->yoreilen );
		memcpy( yorei, p+pHitEnt->yoffs, datasize );
		yorei[ datasize ]	=  '\0';
	}

	if ( pHitEnt->phoneticlen>0 ) {
		datasize	= min( maxphonetic, pHitEnt->phoneticlen );
		memcpy( phonetic, p+pHitEnt->poffs, datasize );
		phonetic[ datasize ]	=  '\0';
	}
#endif
	*level	= pHitEnt->level;

	return 0;
}


//	Ő擪ɈʒuÂ
//	0	
//	-1	s
int CPDicReader::FindFirst()
{
	return SeekIndex( 0 );
}

//	w肵CfbNXԍ̎f[^ubNɈʒuÂ
//	0	
//	-1	s
int CPDicReader::SeekIndex( unsigned long idxno )
{
	byte _titlestr[PDIC_MAX_TITLE+1];	// CfbNXɋL^ꂽo
	int _titlelen;

	m_seq_idxno	= idxno;
	m_seq_datablk	= 0;

	if ( m_pIndex->ReadRec( m_seq_idxno, &m_seq_datablk, (byte*)_titlestr,&_titlelen ) != 0 ) {
		return -1;
	}
	if ( m_pData->ReadBlks( m_seq_datablk ) != 0 ) {
		return -1;
	}

	return 0;
}

#if	defined(UNICODE)
int CPDicReader::MapPhoneticUni( LPCTSTR src,int slen, LPTSTR dest, int maxdest,
							   unsigned short (*CMap)[256][2] )
{
	int i,dlen;
	dlen	= 0;
	for ( i=0; i<slen; ++i ) {
		if ( src[i] >= ' ' && src[i]<256 && (*CMap)[src[i]][0] ) {
			*dest++	= (*CMap)[src[i]][0];
			++dlen;
			if ( (*CMap)[src[i]][1] ) {
				*dest++	= (*CMap)[src[i]][1];
				++dlen;
			}
		}
		else {
			*dest++	= src[i];
			++dlen;
		}
		if ( dlen>=maxdest-1 )
			break;
	}
	*dest	= '\0';
	return dlen;
}

int CPDicReader::MapPhoneticUni( byte* src,int slen, LPTSTR dest, int maxdest,
							   unsigned short (*CMap)[256][2]  )
{
	int i,dlen;
	dlen	= 0;
	for ( i=0; i<slen; ++i ) {
		if ( src[i] >= ' ' && src[i]<256 && (*CMap)[src[i]][0] ) {
			*dest++	= (*CMap)[src[i]][0];
			++dlen;
			if ( (*CMap)[src[i]][1] ) {
				*dest++	= (*CMap)[src[i]][1];
				++dlen;
			}
		}
		else {
			*dest++	= src[i];
			++dlen;
		}
		if ( dlen>=maxdest-1 )
			break;
	}
	*dest	= '\0';
	return dlen;
}

#endif

//	Ŏ̃R[hǂ
//	0	
//	-1	ȏ̃R[h͂Ȃ
int CPDicReader::ReadNext(	LPTSTR title,	//	o(unicodȅꍇAUCS-2)
							LPTSTR honbun,	//	(unicodȅꍇAUCS-2)
							int maxhonbun, 	//	̗̈̍ő咷(max:3000)
							LPTSTR yorei,	//	p(unicodȅꍇAUCS-2)
							int maxyorei,	//	p̗̈̍ő咷(max:20000)
							LPTSTR phonetic,	//	(unicodȅꍇAUCS-2)
							int maxphonetic,	//	̗̈̍ő咷(max:1000)
							int*level,			// Pꃌx
							unsigned short (*phoneticUniMap)[256][2] ,
							PDIC_ITEMINFO *pInfo
							)
{
	ASSERT( title );
	ASSERT( honbun );
	ASSERT( yorei );
	ASSERT( phonetic );

	title[0]	= '\0';
	honbun[0]	= '\0';
	yorei[0]	= '\0';
	phonetic[0]	= '\0';
	*level	= 0;

	byte _titlestr[PDIC_MAX_TITLE+1];	// CfbNXɋL^ꂽo
	int _titlelen,_hoffs,_honbunlen,_yoffs,_yoreilen,_poffs,_phoneticlen,_level;

	// ̃R[hǂ
	if ( m_pData->ReadRec( (byte*)_titlestr, &_titlelen, 
							&_hoffs, &_honbunlen,
							&_yoffs, &_yoreilen,
							&_poffs, &_phoneticlen, &_level, pInfo )!= 0 ) {
		//	f[^ubN̍Ō̃R[h̏ꍇÃf[^ubNǂ

		// CfbNXÃf[^ubN𓾂
		++m_seq_idxno;
		if ( m_pIndex->ReadRec( m_seq_idxno, &m_seq_datablk, (byte*)_titlestr,&_titlelen ) != 0 ) {
			return -1;
		}
		// ̃f[^ubNǂ
		if ( m_pData->ReadBlks( m_seq_datablk ) != 0 ) {
			return -1;
		}
		// ̃R[hǂ
		if ( m_pData->ReadRec( (byte*)_titlestr, &_titlelen,
							&_hoffs, &_honbunlen,
							&_yoffs, &_yoreilen,
							&_poffs, &_phoneticlen, &_level, pInfo )!= 0 ) {
			return -1;
		}
	}
	if ( pInfo ) {
		pInfo->indexno	= m_seq_idxno;
	}

	byte* p = m_pData->GetBuffer();
	byte *_honbun	= p+_hoffs;
	byte *_yorei	= p+_yoffs;
	byte *_phonetic	= p+_poffs;


#if	defined(UNICODE)
	//	UnicodȅꍇABOCU1->UCS2
	if ( m_header.dictype & 0x08 ) {	// BOCU1
		if ( _titlelen>0 ) {
			BOCU1_decode( _titlestr,_titlelen, title, PDIC_MAX_TITLE );
		}
		if ( _honbunlen>0 ) {
			BOCU1_decode( _honbun,_honbunlen, honbun, maxhonbun );
		}
		if ( _yoreilen>0 ) {
			BOCU1_decode( _yorei,_yoreilen, yorei, maxyorei );
		}
		if ( _phoneticlen>0 ) {
			if ( phoneticUniMap ) {
				TCHAR tmp_phonetic[PDIC_MAX_PHONETIC+1];
				BOCU1_decode( _phonetic,_phoneticlen, tmp_phonetic, maxphonetic );
				MapPhoneticUni( tmp_phonetic,_tcslen(tmp_phonetic), phonetic, maxphonetic, phoneticUniMap );
			}
			else {
				BOCU1_decode( _phonetic,_phoneticlen, phonetic, maxphonetic );
			}
		}
	}
	else {
		//	UnicodȅꍇAShiftJIS->UCS2
		int nChar;
		if ( _titlelen>0 ) {
			nChar = ::MultiByteToWideChar(
				  _KANJI_CP,	// R[hy[W	
				  0,			// ̎ނw肷tO
				  (char*)_titlestr,	// }bṽAhX
				  _titlelen,	// }bṽoCg
				  title,		// }bv惏Chobt@̃AhX
				  PDIC_MAX_TITLE	// obt@̃TCY
			);
			title[nChar]	= 0;
		}
		if ( _honbunlen>0 ) {
			nChar = ::MultiByteToWideChar(
				  _KANJI_CP,	// R[hy[W	
				  0,			// ̎ނw肷tO
				  (char*)_honbun,	// }bṽAhX
				  _honbunlen,	// }bṽoCg
				  honbun,		// }bv惏Chobt@̃AhX
				  maxhonbun	// obt@̃TCY
			);
			honbun[nChar]	= 0;
		}
		if ( _yoreilen>0 ) {
			nChar = ::MultiByteToWideChar(
				  _KANJI_CP,	// R[hy[W	
				  0,			// ̎ނw肷tO
				  (char*)_yorei,	// }bṽAhX
				  _yoreilen,	// }bṽoCg
				  yorei,		// }bv惏Chobt@̃AhX
				  maxyorei	// obt@̃TCY
			);
			yorei[nChar]	= 0;
		}
		if ( _phoneticlen>0 ) {
			if ( phoneticUniMap ) {
				MapPhoneticUni( _phonetic,_phoneticlen, phonetic, maxphonetic, phoneticUniMap );
			}
			else {
				int ix;
				for ( ix=0;ix<_phoneticlen;++ix ) {
					phonetic[ix]	= _phonetic[ix];
				}
				phonetic[_phoneticlen]	= 0;
			}
		}
	}
#else
	if ( _titlelen>0 ) {
		ASSERT(_titlelen<=PDIC_MAX_TITLE);
		memcpy( title, _titlestr, _titlelen );
		title[_titlelen]	=  '\0';
	}
	if ( _honbunlen>0 ) {
		ASSERT(_honbunlen<=maxhonbun);
		memcpy( honbun, _honbun, _honbunlen );
		honbun[_honbunlen]	=  '\0';
	}
	if ( _yoreilen>0 ) {
		ASSERT(_yoreilen<=maxyorei);
		memcpy( yorei, _yorei, _yoreilen );
		yorei[_yoreilen]	=  '\0';
	}
	if ( _phoneticlen>0 ) {
		ASSERT(_phoneticlen<=maxphonetic);
		memcpy( phonetic, _phonetic, _phoneticlen );
		phonetic[_phoneticlen]	=  '\0';
	}
#endif
	*level	= _level;

	return 0;
}

// PDIC̎eLXgŕ\
void CPDicReader::PDicDumpInfo(  char*pBuf,int maxbuf, int bCRLF)
{
	NEWDIC3_5	*pHeader	= GetHeader();
	if ( !pHeader )
		return;
	int slen	= 0;
	sprintf( pBuf+slen,"[Personal Dictionary]\r\n");
	slen	+=	strlen(pBuf+slen);	if ( slen>=maxbuf-255 ) return;

	// (dictitle)
//	sprintf( pBuf+slen,"dictitle = %s\r\n", pHeader->dictitle );
//	slen	+=	strlen(pBuf+slen);	if ( slen>=maxbuf-255 ) return;

	// ̃o[W(version)
	sprintf( pBuf+slen,"version = %d.%02d\r\n", pHeader->version>>8,
											pHeader->version & 0xff  );
	slen	+=	strlen(pBuf+slen);	if ( slen>=maxbuf-255 ) return;

	// o̍ő咷(lword)	
	sprintf( pBuf+slen,"lword = %d\r\n", pHeader->lword );
	slen	+=	strlen(pBuf+slen);	if ( slen>=maxbuf-255 ) return;

	// ̍ő咷(ljapa)
	sprintf( pBuf+slen,"ljapa = %d\r\n", pHeader->ljapa );
	slen	+=	strlen(pBuf+slen);	if ( slen>=maxbuf-255 ) return;

	// ubÑoCg(block_size)	
	sprintf( pBuf+slen,"block_size = %d\r\n", pHeader->block_size );
	slen	+=	strlen(pBuf+slen);	if ( slen>=maxbuf-255 ) return;

	// CfbNXubN(index_block)
	sprintf( pBuf+slen,"index_block = %d\r\n", pHeader->index_block );
	slen	+=	strlen(pBuf+slen);	if ( slen>=maxbuf-255 ) return;

	// wb_(header_size)
	sprintf( pBuf+slen,"header_size = %d\r\n", pHeader->header_size );
	slen	+=	strlen(pBuf+slen);	if ( slen>=maxbuf-255 ) return;

	// o^Pꐔ(nword)
	sprintf( pBuf+slen,"nword   = %d\r\n", pHeader->nword );
	slen	+=	strlen(pBuf+slen);	if ( slen>=maxbuf-255 ) return;

	// ̏(dicorder)
	sprintf( pBuf+slen,"dicorder= [%02x] %s\r\n", 
		pHeader->dicorder,
		(pHeader->dicorder == 0x00 )?"code order ":
		(pHeader->dicorder == 0x01 )?"ignore case ":
		(pHeader->dicorder == 0x02 )?"lexicographic order ":
		(pHeader->dicorder == 0x03 )?"descending order ":
				""
		);
	slen	+=	strlen(pBuf+slen);	if ( slen>=maxbuf-255 ) return;

	// ̎(dictype)
	sprintf( pBuf+slen,"dictype = [%02x] %s\r\n", 
		pHeader->dictype,
		(pHeader->dictype == 0x01)?"AR compressed":
		(pHeader->dictype == 0x08)?"BOCU-1 compressed":
		(pHeader->dictype == 0x09)?"AR compressed / BOCU-1 compressed":
									""
		);
	slen	+=	strlen(pBuf+slen);	if ( slen>=maxbuf-255 ) return;

	// Pꑮ̒(attrlen)
	sprintf( pBuf+slen,"attrlen = %d\r\n", pHeader->attrlen );
	slen	+=	strlen(pBuf+slen);	if ( slen>=maxbuf-255 ) return;

	// os type
	sprintf( pBuf+slen,"os      = [%02x] %s\r\n", 
		pHeader->os,
		(pHeader->os==0x00)?"DOS,Windows,OS/2":
		(pHeader->os==0x01)?"Mac":
		(pHeader->os==0x02)?"UNIX - SJIS":
		(pHeader->os==0x03)?"UNIX - EUC":
		(pHeader->os==0x04)?"UNIX - JIS":
		(pHeader->os==0x20)?"BOCU encoding":
		""
		);
	slen	+=	strlen(pBuf+slen);	if ( slen>=maxbuf-255 ) return;

	// index_blkbit; // 0:16bit, 1:32bit
	sprintf( pBuf+slen,"index_blkbit = [%02x] %s\r\n", 
		pHeader->index_blkbit,
		(pHeader->index_blkbit==0x00)?"16bit":
		(pHeader->index_blkbit==0x01)?"32bit":
		""
		);
	slen	+=	strlen(pBuf+slen);	if ( slen>=maxbuf-255 ) return;

	// CfbNXvf̐(nindex2)
	sprintf( pBuf+slen,"nindex2 = %d\r\n", pHeader->nindex2 );
	slen	+=	strlen(pBuf+slen);	if ( slen>=maxbuf-255 ) return;

	// gpf[^ubN
	sprintf( pBuf+slen,"nblock2 = %d\r\n", pHeader->nblock2 );
	slen	+=	strlen(pBuf+slen);	if ( slen>=maxbuf-255 ) return;


}


//////////////////////////////////////////////////////////////////////
// CfbNX
//////////////////////////////////////////////////////////////////////

CPDicIndex::CPDicIndex( FILE*fp,
					   NEWDIC3_5 *header
					   )
{
	ASSERT( fp );
	ASSERT( header );

	m_fp		= fp;
	m_header	= header;
	m_pdic_ver = (m_header->version) >> 8;

	m_indexTbl	= NULL;
	m_maxIndex	= 0;

}

CPDicIndex::~CPDicIndex()
{
	if ( m_indexTbl ) {
		free( m_indexTbl );
		m_indexTbl	= NULL;
	}
}

#ifdef _WIN32_WCE
// obt@tread(WindowsCEReadFile()obt@Oꂸ)
int buffered_read( byte*_iobuf,			// I/Oobt@
				  unsigned int bufsize,	// I/Oobt@̃TCY
				  byte**_bufp,			// I/Oobt@̃|C^(ĺA_iobuf+bufsizeƂ邱)
				  int size,				// ̓f[^̃TCY
				  byte*outbuf,			// ̓f[^i[̈
				  FILE*m_fp				// file pointer
				  )
{
	int _written = 0;
	while ( _written < size ) {
		if ( (*_bufp) < _iobuf+bufsize ) {
			*outbuf++	= **_bufp;
			(*_bufp)++;
			++_written;
		}
		else {
			if ( fread( _iobuf, 1, bufsize, m_fp ) != bufsize )	
				return _written;
			*_bufp	= _iobuf;
			*outbuf++	= **_bufp;
			(*_bufp)++;
			++_written;
		}
	}
	return _written;
}
#endif

//	CfbNXǂݎAzɊi[
//	0	
//	-1	s
int	CPDicIndex::LoadIndex()
{
	unsigned long	_curIdxNo;
	unsigned long _curoffs	= 0;	// CfbNX擪̃ItZbg

	m_maxIndex	= m_header->nindex2;
	m_indexTbl	= (PDIC_INDEX*)malloc( (m_maxIndex+1)*sizeof(PDIC_INDEX) );
	memset( m_indexTbl, 0, (m_maxIndex+1)*sizeof(PDIC_INDEX) );

//	if ( fseek( m_fp, PDIC_HEADER_256, SEEK_SET ) ) {
	if ( fseek( m_fp, m_header->header_size, SEEK_SET ) ) {
		return -1;
	}
#ifdef _WIN32_WCE
	byte _iobuf[PDIC_MAX_BLKLEN];
	byte *_bufp = _iobuf+m_header->block_size;
#endif
	byte _buffer[4];

	unsigned long _blk;
	for ( _curIdxNo = 0; _curIdxNo<m_maxIndex; ++_curIdxNo ) {
		if ( _curoffs >=m_maxIndex*m_header->block_size )
			break;

		_blk	=	0;
		if ( m_header->index_blkbit == 1 ) {
#ifdef _WIN32_WCE
			if ( buffered_read( _iobuf,m_header->block_size, &_bufp, 4, _buffer, m_fp )!= 4 )	break;
#else
			if ( fread( _buffer, 1, 4, m_fp ) != 4 )	break;
#endif
			_blk	= (_buffer[0])
					+ (_buffer[1]<<8)
					+ (_buffer[2]<<16)
					+ (_buffer[3]<<24);
			_curoffs	+= 4;
		}
		else {
#ifdef _WIN32_WCE
			if ( buffered_read( _iobuf,m_header->block_size, &_bufp, 2, _buffer, m_fp )!= 2 )	break;
#else
			if ( fread( _buffer, 1, 2, m_fp ) != 2 )	break;
#endif
			_blk	= (_buffer[0]) + (_buffer[1]<<8);
			_curoffs	+= 2;
		}
		m_indexTbl[_curIdxNo].offs		= _curoffs;
		m_indexTbl[_curIdxNo].blkno	= _blk;
		int _titlelen	= 0;
#ifdef _WIN32_WCE
		while ( buffered_read( _iobuf,m_header->block_size, &_bufp, 1, _buffer, m_fp )>0 ) {
#else
		while ( fread( _buffer, 1, 1, m_fp )>0 ) {
#endif
			++_titlelen;
			if ( !_buffer[0] )
				break;
		}
		m_indexTbl[_curIdxNo].titlelen	= _titlelen - 1;
		_curoffs	+= _titlelen;

		if ( m_indexTbl[_curIdxNo].blkno == 0 && m_indexTbl[_curIdxNo].titlelen == 0 ) {
			// I
			break;
		}
	}

	return 0;
}

//	CfbNXubNł̏Ggread
//	0	
//	-1	ȏ̃R[h͂Ȃ
int	CPDicIndex::ReadRec( unsigned long idxno,	// CfbNXԍ(0..nindex2)
						unsigned long *datablk,
						byte*title,
						int *titlelen )
{
	if ( idxno>=(unsigned long)m_header->nindex2 ) 
		return -1;
	ASSERT( idxno>=0 && (long)idxno<m_header->nindex2 );

	if ( !m_indexTbl ) {
		LoadIndex();	// CfbNXǂݍ
	}

//	if ( fseek( m_fp, PDIC_HEADER_256 + m_indexTbl[idxno].offs, SEEK_SET ) ) {
	if ( fseek( m_fp, m_header->header_size + m_indexTbl[idxno].offs, SEEK_SET ) ) {
#if  defined(_WIN32_WCE)
		RaiseException(	EXCEPTION_CODE,	/*DWORD dwExceptionCode*/
						0,		/*DWORD dwExceptionFlags*/
						0,		/*DWORD nNumberOfArguments*/
						NULL);	/*ULONG_PTR *lpArguments*/	
#else
		throw;
#endif
//		return -1;
	}
	ASSERT( m_indexTbl[idxno].titlelen<=PDIC_MAX_TITLE );
	if ( fread( title, m_indexTbl[idxno].titlelen+1,1, m_fp ) == 0 ) {
		return -1;
	}
	*datablk	= m_indexTbl[idxno].blkno;
	*titlelen	= m_indexTbl[idxno].titlelen;

	return 0;
}


//	CfbNX\oCiT[`ōłߖT̃CfbNX
// uCɂŐVASYTvF
int CPDicIndex::BSearchIndex( LPCTSTR keyword )
{
	unsigned long	datablk;
	int	_titlelen;
	byte _title[PDIC_MAX_TITLE+1];
#if	defined(UNICODE)
	int	nChar;
	TCHAR	w_idxkey[PDIC_MAX_TITLE+1];
	byte	mb_keyword[PDIC_MAX_TITLE+1];
#endif
	int	keywordlen;

	if ( !m_indexTbl ) {
		LoadIndex();	// CfbNXǂݍ
	}

#if	defined(UNICODE)
	if ( m_header->dictype & 0x08 ) {	// BOCU1
		keywordlen	= _tcslen(keyword);
	}
	else {
		nChar = ::WideCharToMultiByte( _KANJI_CP, NULL, keyword, _tcslen(keyword), 
					(LPSTR)mb_keyword, PDIC_MAX_TITLE, NULL, NULL);	// ϊ(ShiftJIS)
		mb_keyword[nChar]	= '\0';
		keywordlen	= nChar;
	}
#else
	keywordlen	= _tcslen(keyword);
#endif

	int left	= 0;	// CfbNX̃ubNԍ
	int right	= m_header->nindex2;
	int mid;
	while ( left < right ) {
		mid = ( left + right ) / 2;
		if ( ReadRec( mid, &datablk,_title,&_titlelen ) ) 
			return 0;
		int	comp;
		////////////////////////////////////////////////////
		// ȉdicorder == 0 (R[h)̏ꍇ
		////////////////////////////////////////////////////
#if	defined(UNICODE)
		//	UnicodȅꍇABOCU1->UCS2ɕϊĔr
		if ( m_header->dictype & 0x08 ) {	// BOCU1
			BOCU1_decode( _title,_titlelen, w_idxkey,PDIC_MAX_TITLE );
			comp	= _tcsncmp( w_idxkey , keyword, keywordlen );
		}
		else {
			//	UnicodȅꍇAShiftJISŔriR[hj
			//	 _mbsncmp()͂܂Ȃ
			comp = strncmp( (char*)_title, (char*)mb_keyword, keywordlen ) ;
		}
#else
		//	 _mbsncmp()͂܂Ȃ
		comp	= strncmp( (char*)_title , keyword, keywordlen );
#endif
		if ( comp < 0 ) 
			left = mid + 1; 
		else 
			right = mid;
	}
	return max(0,left-1);
}

//////////////////////////////////////////////////////////////////////
// f[^
//////////////////////////////////////////////////////////////////////

CPDicData::CPDicData(FILE*fp,NEWDIC3_5 *header)
{
	ASSERT( fp );
	ASSERT( header );

	m_fp	= fp;
	m_header	= header;
	m_pdic_ver = (m_header->version) >> 8;
	m_curBlk	= 0xFFFFFFFF;
	m_recOffs	= 0;
	m_blocks	= 0;	// gpubN
	m_maxblocks	= 0;
	m_blkbuf	= NULL;
}

CPDicData::~CPDicData()
{
	if ( m_blkbuf ) {
		free( m_blkbuf );
		m_blkbuf	= NULL;
	}
}

// Af[^ubN̐擪AhXԂ
byte*CPDicData::GetBuffer()
{
	return m_blkbuf;
}

unsigned long CPDicData::GetOffs()
{
	return m_recOffs;
}

unsigned long CPDicData::GetBlkNo()	// ݂̘AubN擪ԍ
{
	return m_curBlk;
}

// blknon܂Af[^ubNǂ
//	ubN̘A̋@\NEWDIC3ȍ~
//	0	
//	-1	s
int	CPDicData::ReadBlks( unsigned long blkno	/*f[^̕ubNԍ*/ )
{
	/*
		擪ubNMSB	0:	tB[h2oCg
							1:	tB[h4oCg
		擪ubN̐擪2oCg͎gpubN;0Ȃ󂫃ubN
		ubN256oCg
		gpubN>1ȂAubN
	*/
	if ( m_curBlk == blkno ) {
		// ǂݍݍ
		m_recOffs	= 2;	// gpubNǂݔ΂
		return 0;
	}
	m_curBlk	= blkno;
	m_recOffs	= 0;

	// 擪ubNǂ
	if ( ReadBlk( blkno ) ) 
		return -1;

	// tB[ȟƎgpubN𓾂
	m_blocks	= LTWOBYTEUINT(m_buffer);
	if ( m_blocks & 0x8000 ) {
		m_fieldSize	= 4;
	}
	else {
		m_fieldSize	= 2;
	}
	m_blocks	&= 0x7FFF;
	// gpubN0Ȃ󂫃ubNł
	if ( m_blocks == 0 ) 
		return -1;	// 󂫃ubN

	//	gpubN邾̗̈𓮓IɊ蓖Ă
	if ( m_maxblocks == 0 ) {
		m_blkbuf	= (byte*)malloc( m_blocks*m_header->block_size );
		m_maxblocks	= m_blocks;
	}
	else if ( m_maxblocks < m_blocks ) {
		m_blkbuf	= (byte*)realloc( m_blkbuf, m_blocks*m_header->block_size );
		m_maxblocks	= m_blocks;
	}
	memset( m_blkbuf, 0, m_blocks*m_header->block_size );
	memcpy( m_blkbuf+0, m_buffer, m_header->block_size );

	// AubNɓǂݍ
	int	_blks;
	for ( _blks = 1;_blks<m_blocks ; ++_blks ) {
		if ( ReadBlk( blkno+_blks ) ) 
			break;
		memcpy( m_blkbuf+_blks*m_header->block_size, m_buffer, m_header->block_size );
	}
	//	擪R[hʒuɐݒ
	m_recOffs	= 2;	// gpubNǂݔ΂
	return 0;
}

// Ǎς̘Af[^ubNAɃR[hǂ
//	eNULLɂĂ悢B̏ꍇAcallerɕʂȂ
//	0	R[h
//	-1	ȏ̃R[h͂Ȃ
int	CPDicData::ReadRec( byte* title,	// o̓Ǐö(callerɕʂ)
										//	NULLɂƕʂȂ
						int	*titlelen,	// title̍ő咷()
						int	*hoffs,		// ̊JnʒuItZbg
						int	*honbunlen,	// ̒()
						int	*yoffs,		// p̊JnʒuItZbg
						int	*yoreilen,	// p̒
						int *poffs,		// ̊JnʒuItZbg
						int *phoneticlen,	// ̒
						int *level,		// Pꃌx
						PDIC_ITEMINFO *pInfo
						)
{

	/*
	f[^F
	Unicode
	================================
			TCY	l
	̨ޒ	2 ޲	oꂩ̍Ō܂ł޲ĒPʂ̒(̨ޒAk͊܂߂Ȃ)
	k		1 ޲	oꕔ̈kĂ钷
	o		ϒ	NULL I[ kĂ
	oꑮ	1 ޲	
					0x80 K
					4bit Pꃌxl(0-15)
					0x10 g\tO
					0x20 ËLK{PtO
					0x40 CPtO
			ϒ	NULL I[

	Unicode
	================================
			TCY	l
	̨ޒ	2 ޲	oꂩ̍Ō܂ł޲ĒPʂ̒(̨ޒAoꑮAk͊܂߂Ȃ)
						̃TCY̓f[^ubN̐擪̍ŏʃrbgɂČ܂B
	k		1 ޲	oꕔ̈kĂ钷(oCgP)
	oꑮ	1 ޲	oʒuႤ
	o		ϒNULL I[	kčoꕔ	BOCU1 encoding
			ϒNULL I[	BOCU1 encoding
	*/

	ASSERT( m_recOffs>=2 && m_recOffs< m_blocks*m_header->block_size);
	ASSERT( m_blkbuf );

	int	_fieldLen,_complen,_titlelen,_honbunlen;
	int	_ext_attr,_ext_len;
	int	nextoffs;
	byte	_title_attr;
	PDIC_ITEMINFO info;

/*
	if ( titlelen )		*titlelen	= 0;
	if ( honbunlen )	*honbunlen	= 0;
	if ( yoreilen )	*yoreilen	= 0;
	if ( phoneticlen )	*phoneticlen	= 0;
	if ( hoffs )	*hoffs	= 0;
	if ( yoffs )	*yoffs	= 0;
	if ( poffs )	*poffs	= 0;
	if ( level )	*level	= 0;
*/
	memset( &info,0,sizeof(PDIC_ITEMINFO) );
	info.blkno		= GetBlkNo();
	info.recOffs	= m_recOffs;
		
	// (1)tB[h
	if ( m_fieldSize == 4 ) {
		_fieldLen	= LFOURBYTEUINT(m_blkbuf+m_recOffs);
		m_recOffs	+=	4;
	}
	else {
		_fieldLen	= LTWOBYTEUINT(m_blkbuf+m_recOffs);
		m_recOffs	+=	2;
	}
	if ( _fieldLen == 0 ) {
		return -1;	// I
	}

	// (2)k
	_complen	= m_blkbuf[m_recOffs];
	++m_recOffs;

	if ( m_header->dictype & 0x08 ) {	// BOCU1
		// (3)oꑮ
		_title_attr	= m_blkbuf[m_recOffs];
		++m_recOffs;

		//	tB[h́Aoꂩ̍Ō܂ł̃oCgPʂ̒
		nextoffs	= m_recOffs+_fieldLen;
		// (4)o NULLI[
		_titlelen	= strlen( (char*)m_blkbuf+m_recOffs);
		int _full_titlelen	= _complen+_titlelen;
		ASSERT( _full_titlelen <= PDIC_MAX_TITLE );
		strncpy( (char*)m_lastTitle+_complen, (char*)m_blkbuf+m_recOffs,_titlelen );
		m_lastTitle[ _full_titlelen ]	= 0;
		if ( title ) {  
			strncpy( (char*)title,(char*)m_lastTitle,_full_titlelen );
			title[ _full_titlelen ]	= 0;
		}
		info.titlelen	= _full_titlelen;

		m_recOffs	+= _titlelen + 1;

		// (5) NULLI[
		info.hoffs	= m_recOffs;
		if ( _title_attr & 0x10 ) {	// g
			_honbunlen	= strlen( (char*)m_blkbuf+m_recOffs);
			info.hoffs	= m_recOffs;
			info.honbunlen	= _honbunlen;

			m_recOffs	+=	_honbunlen + 1;
			//	̌ɁAg
			while( m_recOffs<=nextoffs ) {
				//	g
				_ext_attr	= m_blkbuf[m_recOffs];
				++m_recOffs;
				if ( _ext_attr == 0x80 ) {
					break;
				}
				else if ( _ext_attr & 0x10 ) {	// binary
					if ( m_fieldSize == 4 ) {
						_ext_len	= LFOURBYTEUINT(m_blkbuf+m_recOffs);
						m_recOffs	+=	4;
					}
					else {
						_ext_len	= LTWOBYTEUINT(m_blkbuf+m_recOffs);
						m_recOffs	+=	2;
					}
					// ǂݔ΂
					m_recOffs	+=	_ext_len;
				}
				else {
					_ext_len	= strlen( (char*)m_blkbuf+m_recOffs);
					if ( _ext_attr == 0x01 ) {	// p
						info.yoffs		= m_recOffs;
						info.yoreilen	= _ext_len;
					}
					else if ( _ext_attr == 0x02 ) {	// L
						info.poffs	= m_recOffs;
						info.phoneticlen	= _ext_len;
					}
					m_recOffs	+=	_ext_len+1;
				}
			}
			ASSERT( m_recOffs == nextoffs );
			m_recOffs	=	nextoffs;
		}
		else {	// g
			_honbunlen	= nextoffs - m_recOffs;
			info.hoffs	= m_recOffs;
			info.honbunlen	= _honbunlen;
			m_recOffs	= nextoffs;
		}
		info.level	= _title_attr & 0x0f;
	}
	else {
		// (3)o NULLI[
		_titlelen	= strlen( (char*)m_blkbuf+m_recOffs);
		int _full_titlelen	= _complen+_titlelen;
		ASSERT( _full_titlelen <= PDIC_MAX_TITLE );
		strncpy( (char*)m_lastTitle+_complen, (char*)m_blkbuf+m_recOffs,_titlelen );
		m_lastTitle[ _full_titlelen ]	= 0;
		if ( title ) {  
			strncpy( (char*)title,(char*)m_lastTitle,_full_titlelen );
			title[ _full_titlelen ]	= 0;
		}
		info.titlelen	= _full_titlelen;

		m_recOffs	+= _titlelen + 1;
		// (4)oꑮ
		_title_attr	= m_blkbuf[m_recOffs];
		++m_recOffs;

		// (5) g̏ꍇNULLI[
		if ( _title_attr & 0x10 ) {	// g
			_honbunlen	= strlen( (char*)m_blkbuf+m_recOffs);
			info.hoffs	= m_recOffs;
			info.honbunlen	= _honbunlen;

			nextoffs	= m_recOffs	+ _fieldLen - _titlelen - 2;
			m_recOffs	+=	_honbunlen + 1;
			//	̌ɁAg
			while( m_recOffs<=nextoffs ) {
				//	g
				_ext_attr	= m_blkbuf[m_recOffs];
				++m_recOffs;
				if ( _ext_attr == 0x80 ) {
					break;
				}
				else if ( _ext_attr & 0x10 ) {	// binary
					if ( m_fieldSize == 4 ) {
						_ext_len	= LFOURBYTEUINT(m_blkbuf+m_recOffs);
						m_recOffs	+=	4;
					}
					else {
						_ext_len	= LTWOBYTEUINT(m_blkbuf+m_recOffs);
						m_recOffs	+=	2;
					}
					// ǂݔ΂
					m_recOffs	+=	_ext_len;
				}
				else {
					_ext_len	= strlen( (char*)m_blkbuf+m_recOffs);
					if ( _ext_attr == 0x01 ) {	// p
						info.yoffs	= m_recOffs;
						info.yoreilen	= _ext_len;
					}
					else if ( _ext_attr == 0x02 ) {	// L
						info.poffs	= m_recOffs;
						info.phoneticlen	= _ext_len;
					}
					m_recOffs	+=	_ext_len+1;
				}
			}
			ASSERT( m_recOffs == nextoffs );
			m_recOffs	=	nextoffs;
		}
		else {	// g
			_honbunlen	= _fieldLen - _titlelen - 2;
			info.hoffs	= m_recOffs;
			info.honbunlen	= _honbunlen;
			m_recOffs	+= _honbunlen;
		}
		info.level	= _title_attr & 0x0f;
	}

	if ( titlelen )		*titlelen	= info.titlelen;
	if ( hoffs )		*hoffs		= info.hoffs;
	if ( honbunlen )	*honbunlen	= info.honbunlen;
	if ( yoffs )		*yoffs		= info.yoffs;
	if ( yoreilen )		*yoreilen	= info.yoreilen;
	if ( poffs )		*poffs		= info.poffs;
	if ( phoneticlen )	*phoneticlen	= info.phoneticlen;
	if ( level )		*level		= info.level;

	if ( pInfo )	{
		info.blocks		= m_blocks;
		info.fieldSize	= m_fieldSize;
		*pInfo			= info;
	}

	return 0;
}

// I/F	f[^ubNǂ
//	0	
//	-1	s
int	CPDicData::ReadBlk( unsigned long blkno )
{
	unsigned long seekoffs;
	//	Seek
	if ( (m_header->version>>8) >= 4 ) {
		seekoffs	= m_header->header_size
					+ m_header->extheader
					+ m_header->index_block * m_header->block_size
					+ m_header->block_size * blkno;
	}
	else {
		seekoffs	= m_header->header_size
					+ m_header->index_size
					+ m_header->block_size * blkno;
	}
	if ( fseek( m_fp, seekoffs, SEEK_SET ) ) {
//		return -1;
#if  defined(_WIN32_WCE)
		RaiseException(	EXCEPTION_CODE,	/*DWORD dwExceptionCode*/
						0,		/*DWORD dwExceptionFlags*/
						0,		/*DWORD nNumberOfArguments*/
						NULL);	/*ULONG_PTR *lpArguments*/	
#else
		throw;
#endif
	}

	//	f[^ubNǂ
	if ( fread( m_buffer, 1, m_header->block_size, m_fp )
					!= (unsigned int)m_header->block_size ) {
		return -1;
	}

	return 0;
}

